/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: labelset.c,v 1.2 2000/08/01 10:10:36 bazsi Exp $
 *
 ***************************************************************************/

#include <string.h>
#include <zorp/zorp.h>

#include <zorp/labelset.h>

ZLabelSet *
z_label_set_new(void)
{
  int i;
  ZLabelSet *self = g_new(ZLabelSet, 1);

  self->rmax = self->wmin = -1;
  self->group_ctr = self->nhc_ctr = 0;

  for (i = 0; i < Z_LABELSET_MAX_GROUP; i++)
    self->groups[i] = NULL;
  for (i = 0; i < Z_LABELSET_MAX_NHC; i++)
    self->nhcs[i] = NULL;

  self->refcnt = 1;
  return self;
}

ZLabelSet *
z_label_set_ref(ZLabelSet * self)
{
  self->refcnt++;
  return self;
}

void
z_label_set_unref(ZLabelSet * self)
{
  int i;

  if (--self->refcnt == 0)
    {
      for (i = 0; i < self->group_ctr; i++)
	g_free(self->groups);
      for (i = 0; i < self->nhc_ctr; i++)
	g_free(self->nhcs);
      g_free(self);
    }
}

void
z_label_set_add_group(ZLabelSet * self, char *grp)
{
  if (self->group_ctr == Z_LABELSET_MAX_GROUP)
    return;

  self->groups[self->group_ctr++] = strdup(grp);
}

void
z_label_set_add_nhc(ZLabelSet * self, char *nhc)
{
  if (self->nhc_ctr == Z_LABELSET_MAX_NHC)
    return;

  self->nhcs[self->nhc_ctr++] = strdup(nhc);
}
