/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This is unpublished source code from BalaBit IT Ltd, and is trade secret. 
 * As such, it must be protected by all possible means to prevent
 * unauthorized access.
 *
 * $Id: authconn.h,v 1.4 2000/08/02 09:18:24 bazsi Exp $
 *
 ***************************************************************************/

#ifndef ZORP_AUTHCONN_H_INCLUDED
#define ZORP_AUTHCONN_H_INCLUDED

#include <zorp/sockaddr.h>
#include <zorp/labelset.h>

#include <openssl/ssl.h>

#define ZAC_TCP 1
#define ZAC_SSL 2

typedef struct _ZAuthConnection
{
  int sock;
  int type;
  SSL *ssl;
  ZSockAddr *sa;
  char *myname;
  char *peername;
}
ZAuthConnection;

int z_authconn_init(char *cert, char *priv);
ZAuthConnection *z_authconn_new_ssl(ZSockAddr *, char *);
ZAuthConnection *z_authconn_new_tcp(ZSockAddr *, char *);
void z_authconn_destroy(ZAuthConnection *);
ZLabelSet *z_authconn_auth(ZAuthConnection *,
			   char *type, char *dn, char *chal, char *resp);
int z_authconn_chal(ZAuthConnection *, char *type, char *dn,
		    char *buf, int len);
char **z_authconn_type(ZAuthConnection *, int *count);
char **z_authconn_utyp(ZAuthConnection *, char *dn, int *count);
void z_authconn_free(char **what);

#endif
