/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: ftpparse.h,v 1.6 2000/08/08 16:48:57 bazsi Exp $
 *
 * Author:  Andras Kis-Szabo <kisza@sch.bme.hu>
 * Auditor:
 * Notes:
 *
 ***************************************************************************/


#ifndef __FTP_PARSE_H
#define __FTP_PARSE_H

void ftp_answerstate (gpointer s);
guint ftp_stream_write (FtpProxy * self, char dir, char *line, int length);
int ftp_log (gpointer s, gint from, gchar * msg, int length);
int ftp_sendback (FtpProxy * self, gchar * msg);
guint ftp_command_drop (FtpProxy * self, char *line, int length, char *msg);

unsigned int ftp_get_port (FtpProxy * self,const char * ip,int side);
void ftp_test(FtpProxy * self);
guint ftp_data_channel (FtpProxy * self, FTPCommandDescriptor * command);

int ftp_command_parse_noarg (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_PASV (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_sftp (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_string (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_marker (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_path (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_ALLO (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_USER (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_PASS (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_ACCT (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_QUIT (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_HELP (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_REIN (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_PORT (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_TYPE (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_STRU (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_MODE (FtpProxy * self, char *line, int length, FTPCommandDescriptor * command);
int ftp_command_parse_UNKN (FtpProxy * self, char *line, int length, long flag);

#endif
