/***************************************************************************
 *
 * Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: httpstr.c,v 1.11 2000/08/08 14:47:17 bazsi Exp $
 *
 * By: Kovacs Viktor Peter (vps__@hotmail.com | vps__@freemail.hu | ...)
 *
 * HttpStr: dynamic string libray v2.0.2
 *
 ***************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include "httpstr.h"

#define HTTP_STR_GRAN (4096)

#define TRUE  (1)
#define FALSE (0)

/* 
//public
typedef struct _HttpStr{
 char* str;
 int len;
 int alen;
}HttpStr;

void  http_str_init(HttpStr* s);
void  http_str_free(HttpStr* s);

void  http_str_set(HttpStr* s, HttpStr* ns);
void  http_str_sets(HttpStr* s, char* ns);
void  http_str_add(HttpStr* s, HttpStr* ns);
void  http_str_adds(HttpStr* s, char* ns);
int   http_str_len(HttpStr* s);
char* http_str_str(HttpStr* s);
*/

//private
void http_str_exeption(void)
{
 //log and terminate
 assert(TRUE);
}

int http_str_roundup(int a)
{
 return(((a/HTTP_STR_GRAN)+1)*HTTP_STR_GRAN);
}

void http_str_alloc(HttpStr* s, int nsize)
{
 int t;
 t=http_str_roundup(nsize+1);

 if(s->str==NULL)
 {
  s->str=malloc(t);
  if(s->str==NULL) http_str_exeption();
  *(s->str)=0;
 }else if(s->alen!=t)
 {
  s->str=realloc(s->str, t);
  if(s->str==NULL) http_str_exeption();
 }
 *((s->str)+nsize)=0;
 s->alen=t;
 s->len=nsize;
} 

char http_str_ucase(char c)
{
 if(c>='a' && c<='z') return(c-'a'+'A');
 return(c);
}

void http_str_init(HttpStr* s)
{
 s->alen=0;
 s->str=NULL;
 http_str_alloc(s, 0);
}

void http_str_free(HttpStr* s)
{
 if(s->str!=NULL) free(s->str); 
 s->str=NULL;
 s->len=0;
 s->alen=0;
}

void  http_str_set(HttpStr* s, HttpStr* ns)
{
 http_str_alloc(s, ns->len);
 memcpy(s->str, ns->str, ns->len);
 s->len=ns->len;
}
void  http_str_sets(HttpStr* s, char* ns)
{
 int t;
 t=strlen(ns);
 http_str_alloc(s, t);
 strcpy(s->str, ns);
}
void  http_str_add(HttpStr* s, HttpStr* ns)
{
 int t;
 t=s->len;
 http_str_alloc(s, (s->len)+(ns->len));
 memcpy((s->str)+t, (ns->str), (ns->len));
}
void  http_str_adds(HttpStr* s, char* ns)
{
 int t,t2;
 t=strlen(ns);
 t2=s->len;
 http_str_alloc(s, (s->len)+t);
 memcpy((s->str)+t2, ns, t);
}
void  http_str_addc(HttpStr* s, char ns)
{
 http_str_alloc(s, (s->len)+1);
 (s->str)[(s->len)-1]=ns;
}

int   http_str_len(HttpStr* s)
{
 return(s->len);
}
char* http_str_str(HttpStr* s)
{
 return(s->str);
}

void  http_str_copyn(HttpStr* s, HttpStr* ns, int len)
{
 http_str_alloc(s, len);
 memcpy((s->str), (ns->str), len);
}

void  http_str_allocfill(HttpStr* s, int nlen, char fill)
{
 http_str_alloc(s, nlen);
 memset((s->str), fill, nlen);
}

void  http_str_truncate(HttpStr* s, int nlen)
{
 http_str_alloc(s, nlen);
}

int   http_str_contains_c(HttpStr* s, char c)
{
 int t;
 for(t=0;t<(s->len);t++)
 {
  if((s->str)[t]==c) return(t);
 }
 return(-1);
}

int   http_str_cmpi(HttpStr* a,   HttpStr* b) //terminators: 0x00 0x0A 0x0D len
{
 int t=0;
 while(t<(a->len) && t<(b->len) && 
       (a->str)[t]!=0 && (a->str)[t]!=0x0a && (a->str)[t]!=0x0d &&
       (b->str)[t]!=0 && (b->str)[t]!=0x0a && (b->str)[t]!=0x0d &&
       http_str_ucase((a->str)[t])==http_str_ucase((b->str)[t])
      ){t++;}     
 if(t!=(a->len) && (a->str)[t]!=0 && (a->str)[t]!=0x0a && (a->str)[t]!=0x0d) return(FALSE);
 if(t!=(b->len) && (b->str)[t]!=0 && (b->str)[t]!=0x0a && (b->str)[t]!=0x0d) return(FALSE);
 if(http_str_ucase((a->str)[t])!=http_str_ucase((b->str)[t])) return(FALSE);
 return(TRUE);
}
int   http_str_ncmpi (HttpStr* a,   HttpStr* b, int len)
{
 int t=0;
 while(t<(a->len) && t<(b->len) && t<len &&
       (a->str)[t]!=0 && (a->str)[t]!=0x0a && (a->str)[t]!=0x0d &&
       (b->str)[t]!=0 && (b->str)[t]!=0x0a && (b->str)[t]!=0x0d &&
       http_str_ucase((a->str)[t])==http_str_ucase((b->str)[t])
      ){t++;}     
 if(t==len) return(TRUE);
 return(FALSE);
}

int   http_str_cmpis (HttpStr* a,   char* b)                        //terminators: 0x00 0x0A 0x0D len
{
 int t=0,tt;
 tt=strlen(b);
 while(t<(a->len) && t<tt && 
       (a->str)[t]!=0 && (a->str)[t]!=0x0a && (a->str)[t]!=0x0d &&
       (b)[t]!=0 && (b)[t]!=0x0a && (b)[t]!=0x0d &&
       http_str_ucase((a->str)[t])==http_str_ucase((b)[t])
      ){t++;}     
 if(t!=(a->len) && (a->str)[t]!=0 && (a->str)[t]!=0x0a && (a->str)[t]!=0x0d) return(FALSE);
 if(t!=tt && (b)[t]!=0 && (b)[t]!=0x0a && (b)[t]!=0x0d) return(FALSE);
 if(http_str_ucase((a->str)[t])!=http_str_ucase((b)[t])) return(FALSE);
 return(TRUE);
}

int   http_str_ncmpis(HttpStr* a,   char* b, int len)
{
 int t=0,tt;
 tt=strlen(b);
 while(t<(a->len) && t<tt && t<len &&
       (a->str)[t]!=0 && (a->str)[t]!=0x0a && (a->str)[t]!=0x0d &&
       (b)[t]!=0 && (b)[t]!=0x0a && (b)[t]!=0x0d &&
       http_str_ucase((a->str)[t])==http_str_ucase((b)[t])
      ){t++;}     
 if(t==len) return(TRUE);
 return(FALSE);
}
