############################################################################
##
## Copyright (c) 2000 BalaBit IT Ltd, Budapest, Hungary
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
##
## $Id: Ftp.py,v 1.11 2000/08/10 15:52:03 bazsi Exp $
##
############################################################################

import Zorp, Service, Connector, Proxy, Session, Stream, SockAddr, Plug
from Zorp import *


class FtpDataConnect:
        state = 0
        parms = [(), ()];
	listens = [None, None]
        data_proxy = None
        fds = [-1, -1]
        session = None

        def __init__(self, session, data_proxy):
        	self.session = session
        	self.data_proxy = data_proxy

	def resetState(self):
		self.listens = [None, None]
		self.state = 0

	def prepare(self, ip, side):
		if (side < 0 or side > 1):
			return 0
		
		self.listens[side] = Zorp.Listen(SockAddr.SockAddrInet(ip, 0), self.acceptedCallback, 1)
		return self.listens[side].local.port

	def start(self, fst_mode, fst_local, fst_remote,
	                snd_mode, snd_local, snd_remote):

                self.parms = [(fst_mode, fst_local, fst_remote),
                	      (snd_mode, snd_local, snd_remote)]
		self.state = 0
                self.processState()
                
        def processState(self):
		Zorp.debug(0, "data listener, state %d" % (self.state))
        	if self.state == 2:
        		# start proxy
			Zorp.debug(0, "stacking data proxy")
			ss = Session.StackedSession(self.session)
			ss.client_fd = self.fds[0]
			ss.client = Stream.Stream(ss.client_fd, ss.session_id + 'data client')
			ss.server_fd = self.fds[1]
			ss.server = Stream.Stream(ss.client_fd, ss.session_id + 'data server')
			self.data_proxy(ss)
        		return
        		
                parms = self.parms[self.state]
                if parms[0] == 'L':
			Zorp.debug(0, "data listener, standard")
                        self.listen = Zorp.Listen(parms[1], self.acceptedCallback, 1)
                        self.listen.start()
                elif parms[0] == 'C':
			Zorp.debug(0, "data connactor")
                        self.connect = Zorp.Connect(parms[1], parms[2], self.connectedCallback)
                elif parms[0] == 'A':
			Zorp.debug(0, "data listener, A")
                	self.listens[0].start()
              	elif parms[0] == 'B':
			Zorp.debug(0, "data listener, B")
              		self.listens[1].start()

        def acceptedCallback(self, client, fd):
		Zorp.debug(0, "data listener, acceptedCallback")
        	self.fds[self.state] = fd
                self.state = self.state + 1
                self.processState()

        def connectedCallback(self, fd):
		Zorp.debug(0, "data listener, connectedCallback")
        	self.fds[self.state] = fd
                self.state = self.state + 1
                self.processState()


# 
# Default FTP proxy - deny all
#
class FtpProxy(Proxy.Proxy):
	data_connect = None

	def __init__(self, session):
		Zorp.debug(0, "FtpProxy()")
		Proxy.Proxy.__init__(self, "ftp", session)
		Zorp.debug(0, "Meg itt vagyok.!.")
		
		self.data_connect = FtpDataConnect(session, Plug.PlugProxy)

	def startUp(self):
		Zorp.debug(0, "MyFtp startUp()")

	def config(self):
		Zorp.debug(0, "MyFtp config()")
		
	def shutDown(self):
		Zorp.debug(0, "MyFtp shutDown()")
		
	def user(self, dir, uname):
		Zorp.debug(0, "FTPE: USER %s , flag %c" % (uname, dir))
		return Z_REJECT

	def password(self, dir, uname):
		Zorp.debug(0, "FTPE: PASS , flag %c" % (dir))
		return Z_REJECT

	def nontransparent(self, dir, dst, user, passw):
		Zorp.debug(0, "FTPE: nont %s %s %s, flag %c" % (dst, user, passw, dir))
		return Z_REJECT

	def userAUTH(self, dir, uname):
		Zorp.debug(0, "FTPE: AUTH %s , flag %c" % (uname, dir))
		return Z_REJECT

	def quit(self, dir):
		Zorp.debug(0, "FTPE: QUIT flag %c" % (dir))
		return Z_REJECT

	def bounceCheck(self, dir, hashv, comm, param):
		Zorp.debug(0, "FTPE: bounce attack detected")
		return Z_REJECT

        def portCommand(self, dir, hashv, comm, param, ip, port):
                Zorp.debug(0, "FTPE: command: %s %s hash: %X flag: %s" % ( comm, param, hashv, dir))
                Zorp.debug(0, "FTPE: %s:%d" % (ip, port))
                return Z_REJECT

        def pasvAnswer(self, dir, line, ip, port):
                Zorp.debug(0, "FTPE: %s flag: %s" % (line, dir))
                Zorp.debug(0, "FTPE: %s:%d" % (ip, port))
                return Z_REJECT

        def answer(self, dir, line):
                Zorp.debug(0, "FTPE: %s flag: %s" % (line, dir))
                return Z_REJECT

	def transferCommand(self, dir, hashv, comm, param):
		Zorp.debug(0, "FTPE: command: %s %s hash: %X flag: %s" % ( comm, param, hashv, dir))
		return Z_REJECT

	def dataTransfer(self, dir, hashv, comm, param):
		Zorp.debug(0, "FTPE: command: %s %s hash: %X flag: %s" % ( comm, param, hashv, dir))
		return Z_REJECT

	def directoryChange(self, dir, hashv, comm, param):
		Zorp.debug(0, "FTPE: command: %s %s hash: %X flag: %s" % ( comm, param, hashv, dir))
		return Z_REJECT

	def directoryManipulation(self, dir, hashv, comm, param):
		Zorp.debug(0, "FTPE: command: %s %s hash: %X flag: %s" % ( comm, param, hashv, dir))
		return Z_REJECT

	def siteCommand(self, dir, hashv, comm, param):
		Zorp.debug(0, "FTPE: command: %s %s hash: %X flag: %s" % ( comm, param, hashv, dir))
		return Z_REJECT

	def mailCommand(self, dir, hashv, comm, param):
		Zorp.debug(0, "FTPE: command: %s %s hash: %X flag: %s" % ( comm, param, hashv, dir))
		return Z_REJECT

	def miscCommand(self, dir, hashv, comm, param):
		Zorp.debug(0, "FTPE: command: %s %s hash: %X flag: %s" % ( comm, param, hashv, dir))
		return Z_REJECT

	def generalCommand(self, dir, hashv, comm, param):
		Zorp.debug(0, "FTPE: command: %s %s hash: %X flag: %s" % ( comm, param, hashv, dir))
		return Z_REJECT

	def unknownCommand(self, dir, comm, param):
		Zorp.debug(0, "FTPE: command: %s %s flag: %s" % ( comm, param, dir))
		return Z_REJECT

	def sendABOR(self, dir):
		Zorp.debug(0, "FTPE: ABOR flag: %s" % ( dir))
		return Z_REJECT

	def prepareDATA(self, ip, side):
		return self.data_connect.prepare(ip, side)

	def startDATA(self, dir, fst_mode, fst_loc_addr, fst_loc_port, fst_rem_addr, fst_rem_port, snd_mode, snd_loc_addr, snd_loc_port, snd_rem_addr, snd_rem_port):
		#
		# mode-ok:
		#  L - listen
		#  C - connect
		#  A - 0. oldal elore foglalt porttal listen
		#  B - 1. oldal elore foglalt porttal listen
		#
		Zorp.debug(0, "FTPE: Rem %s:%d - Loc %s:%d -%c" % (fst_rem_addr, fst_rem_port, fst_loc_addr, fst_loc_port, fst_mode))
		Zorp.debug(0, "FTPE: Rem %s:%d - Loc %s:%d -%c" % (snd_rem_addr, snd_rem_port, snd_loc_addr, snd_loc_port, snd_mode))
		Zorp.debug(0, "FTPE:  %s" % (dir))

		def convertSockAddr(addr, port):
			if addr == '':
				return None
			else:
				return SockAddr.SockAddrInet(addr, port)

		self.data_connect.start(fst_mode, 
					convertSockAddr(fst_loc_addr, fst_loc_port),
					convertSockAddr(fst_rem_addr, fst_rem_port),
					snd_mode,
					convertSockAddr(snd_loc_addr, snd_loc_port),
					convertSockAddr(snd_rem_addr, snd_rem_port))
		return Z_ACCEPT

#
#  Ftp proxy - allows anonymous download
#
class FtpProxyAnonymous(FtpProxy):

	def startUp(self):
		self.command_accept = 0x01BFFFFB

	def config(self):
		self.command_accept = 0x01BFFFFB
		
	def user(self, dir, uname):
		if  ( uname == "anonymous" or uname == "ftp" ):
			return Z_ACCEPT
		else:
			return Z_REJECT

	def password(self, dir, uname):
		return Z_ACCEPT

	def nontransparent(self, dir, dst, user, passw):
		if  ( uname == "anonymous" or uname == "ftp" ):
			return Z_ACCEPT
		else:
			return Z_REJECT

#
# Ftp proxy - R U kidding? Allow all
#
class FtpProxyAllow(FtpProxy):

	def startUp(self):
		self.command_accept = 0x01FFFFFF

	def config(self):
		self.command_accept = 0x01FFFFFF
		
